{
 open AbsSyn
 open Parser
 exception Eof
} 

let spacechar = 
  ['\r' '\n' '\t' ' ']
let textchar = 
  ['!'-';' '=' '?'-'~']
let colorchar = 
  ['r' 'g' 'b' 'c' 'm' 'y' 'k' 'w']

rule token = parse
| textchar + { TEXT(Lexing.lexeme lexbuf) }
| spacechar + { SPACE(Lexing.lexeme lexbuf) }
| "<B>" { ST_B }
| "</B>" { END_B }
| "<EM>" { ST_EM }
| "</EM>" { END_EM }
| "<I>" { ST_I }
| "</I>" { END_I }
| "<PL>" { ST_PL }
| "</PL>" { END_PL }
| "<S>" { ST_S }
| "</S>" { END_S }
| "<TT>" { ST_TT }
| "</TT>" { END_TT }
| "<U>" { ST_U }
| "</U>" { END_U }
| '<' ['0'-'9'] '>' 
    { ST_SIZE(Char.code (Lexing.lexeme_char lexbuf 1) - 48) }
| '<' '/' ['0'-'9'] '>' 
    { END_SIZE(Char.code (Lexing.lexeme_char lexbuf 2) - 48) }
| '<' colorchar '>' 
    { ST_COLOR(Lexing.lexeme_char lexbuf 1) }
| '<' '/' colorchar '>' 
    { END_COLOR(Lexing.lexeme_char lexbuf 2) }
| eof { EOF }
| _ { failwith ("unknown token : " ^ Lexing.lexeme lexbuf) }
