open AbsSyn

open Strtree

let rec pp_elem = function
  | Text s -> from_string s
  | Space s -> from_string s
  | Bold d -> concat [from_string "<B>"; f d; from_string "</B>"]
  | Emph d -> concat [from_string "<EM>"; f d; from_string "</EM>"]
  | Italic d -> concat [from_string "<I>"; f d; from_string "</I>"]
  | Plain d -> concat [from_string "<PL>"; f d; from_string "</PL>"]
  | Strong d -> concat [from_string "<S>"; f d; from_string "</S>"]
  | Typewriter d -> concat [from_string "<TT>"; f d; from_string "</TT>"]
  | Underline d -> concat [from_string "<U>"; f d; from_string "</U>"]
  | Size(i, d) -> concat [from_string (Printf.sprintf "<%d>" i);
			  f d; from_string (Printf.sprintf "</%d>" i)]
  | Color(c, d) ->concat [from_string (Printf.sprintf "<%c>" c);
			  f d; from_string (Printf.sprintf "</%c>" c)]
and f d = concat (List.map pp_elem d)
